SystemOrganization addCategory: #'Asteroid-Core'!
SystemOrganization addCategory: #'Asteroid-Examples-Widgets'!

!HttpResponse methodsFor: '*Asteroid-accessing' stamp: 'dgd 5/9/2006 15:25'!
contentLength: anIntegerOrNil
	contentLength := anIntegerOrNil! !

!ModFile methodsFor: '*Asteroid-processing' stamp: 'dgd 5/9/2006 17:45'!
processHttp
	| fullFilePath method |
	method := ModCore method.
	(#(#GET #POST) includes: method) ifFalse: [^false].
	fullFilePath := ModDoc fullFilePath.
	(FileStream isAFileNamed: fullFilePath) ifFalse: [^false].
	self processSubModules ifTrue: [^true].
	HttpResponse current: (HttpResponse 
				fromStream: (StandardFileStream readOnlyFileNamed: (FileDirectory default fullNameFor: fullFilePath))).
	^true! !

!Socket methodsFor: '*Asteroid-sending' stamp: 'dgd 6/14/2006 20:03'!
pushData: aStringOrByteArray
	"Send aStringOrByteArray to the remote host trough the given socket. Push the data immediately and ignore all kinds of errors. Return true if all the data could be sent successfully, in case of problems destroy the socket and return false."

	| bytesSent bytesToSend |

	bytesSent := 0.
	bytesToSend := aStringOrByteArray size.

	[ bytesSent < bytesToSend ] whileTrue: [
		| count |

		count := self 
						primSocket: socketHandle
						sendData: aStringOrByteArray
						startIndex: bytesSent + 1
						count: (bytesToSend - bytesSent).

		bytesSent := bytesSent + count.

		(count = 0 and: [ bytesSent ~= bytesToSend ]) ifTrue: [
			self destroy.
			^ false
		].

		(Delay forMilliseconds: 5) wait.
	].

	^ true.
! !

Object subclass: #AComet
	instanceVariableNames: 'sockets mutex listenerId pingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Asteroid-Core'!

AComet class
	instanceVariableNames: 'instance'!

AComet subclass: #ACometWidgets
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Asteroid-Examples-Widgets'!

!ACometWidgets class methodsFor: 'running' stamp: 'dgd 5/9/2006 11:56'!
assembleService: assembly


	assembly alias: '/files' to: [
		assembly documentRoot: (FileDirectory default fullNameFor: 'files').
		assembly directoryIndex: 'index.html'.
		assembly serveFiles.
	].

	assembly addPlug: (MessageSend
								receiver: self instance
								selector: #process:
								argument: nil).! !

!ACometWidgets class methodsFor: 'class initialization' stamp: 'dgd 5/20/2006 15:22'!
initialize
	self openCometWidgetsWorkspace! !

!ACometWidgets class methodsFor: 'class initialization' stamp: 'dgd 5/20/2006 15:22'!
openCometWidgetsWorkspace
	"
	ACometWidgets openCometWidgetsWorkspace.
	"
	'"
Asteroid Comet Widgets

- Check the port in ACometWidgets class>>servicePort, the default is 9999
- Start the service
- open more than one browser to http://localhost:9999
"
ACometWidgets start.
ACometWidgets stop.
ACometWidgets reset.

ACometWidgets instance pushAlertHelloWorld.
ACometWidgets instance ping.

ACometWidgets instance.
'  openInWorkspaceWithTitle: 'Asteroid Comet Widgets Workspace'! !

!ACometWidgets class methodsFor: 'running' stamp: 'dgd 5/7/2006 13:12'!
serviceName
	"Answer the receiver's intented service name"

	^ 'CometWidgets2'! !

!ACometWidgets class methodsFor: 'running' stamp: 'dgd 5/7/2006 13:12'!
servicePort
	"Answer the receiver's intented service port"

	^ 9999
! !

!ACometWidgets methodsFor: 'html templates' stamp: 'dgd 9/20/2006 13:43'!
documentTemplate
	^'
<html>
	<head>
		<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="1 Jan 1900 00:00:00 GMT">

		<title>Comet Widgets II</title>' 
		, self style , self scriptLibraryJSON 
		, self scriptLibrary , self script 
		, '

		<script src="/files/prototype.js" type="text/javascript"></script>
		<script src="/files/scriptaculous.js" type="text/javascript"></script>
		<script src="/files/effects.js" type="text/javascript"></script>
	</head>

	<body>
		<div id="log">
			<div>
				<h1>Log</h1>
			</div>
		</div>

		<div id="status">
			<span></span>
			<img src="/files/icon_animated_busy.gif" width="16" height="16" style="visibility: hidden">
		</div>

		<iframe id="CometIFrame" style="visibility: hidden; width:0px; height:0px; border: 0px" src="/SocketServer" onLoad="reconnect(this)">
			Your browsers does not support IFRAME.
		</iframe>

		<h1>How to</h1>
		<ul>
			<li>Open another (or more than one) browser pointing to this url
			<li>Change fields and see what happens in the other browsers
			<li>Kill Squeak process to see how the browsers react
			<li>Rerun Squeak to see how reconnection is posible
		</ul>

		<div id="contents">
			<h1>Comet Widgets II</h1>
			<form id="widgets" name="f">
				Label 1: <input type="text" value="" name="0" onChange="changed(this)" size="50"><br/>
				Label 2: <input type="text" value="" name="1" onChange="changed(this)" size="50"><br/>
				Label 3: <input type="text" value="" name="2" onChange="changed(this)" size="50"><br/>
				Label 4: <input type="text" value="" name="3" onChange="changed(this)" size="50"><br/>
				Label 5: <input type="text" value="" name="4" onChange="changed(this)" size="50"><br/>
			</form>
		</div>
	</body>
</html>
'! !

!ACometWidgets methodsFor: 'private' stamp: 'dgd 5/11/2006 19:30'!
initCometSocket: aCometSocket

	| str |
	str := '
log = top.log;

top.silentlyUpdateWidget(0, "{2}");
top.silentlyUpdateWidget(1, "{3}");
top.silentlyUpdateWidget(2, "{4}");
top.silentlyUpdateWidget(3, "{5}");
top.silentlyUpdateWidget(4, "{6}");

top.connect({1});

' format: {aCometSocket listenerId} , model.

	^ self script: str! !

!ACometWidgets methodsFor: 'initialization' stamp: 'dgd 5/8/2006 19:58'!
initialize
	super initialize.

	model := #(
					'change my value and see'
					'what happens in other'
					'browser pointing to this URL'
					'- N -'
					'TRY IT!!'
				) copy.
! !

!ACometWidgets methodsFor: 'processing' stamp: 'dgd 5/9/2006 15:04'!
process: aRequest 
	^self documentTemplate asHttpResponseTo: aRequest! !

!ACometWidgets methodsFor: 'html templates' stamp: 'dgd 9/28/2006 20:18'!
script
	^ '
<script type="text/javascript">
<!!--

function justConnected() {
	enableWidgets();
	new Effect.Grow("contents");
}

function justDisconnected() {
	disableWidgets();
	new Effect.Shrink("contents");
}

function widgets() {
	return id("widgets").getElementsByTagName("input");
}

function disableWidgets() {
	var ws = widgets();
	for(i=0; i<ws.length; i++){
		ws[i].disabled = true;
	}
}

function enableWidgets() {
	var ws = widgets();
	for(i=0; i<ws.length; i++){
		ws[i].disabled = false;
	}
}

function changed(widget) {
	invokeJsonRPCMethod("widgetChanged:", [ [ListenerId, widget.name, widget.value] ]);
}

function silentlyUpdateWidget(widgetId, newValue) {
	log( "<b>Event:</b> Widget " + widgetId.toString() + " has changed value to: " + newValue.toString());

	var w = id("widgets").getElementsByTagName("input")[widgetId];
	w.value = newValue;
}

function updateWidget(widgetId, newValue) {
	silentlyUpdateWidget(widgetId, newValue);

	var w = id("widgets").getElementsByTagName("input")[widgetId];
	new top.Effect.Shake(w);

	var options = new Object();
	options["startcolor"] = "#ff9999";
	options["endcolor"] = "#ffffff";
	new top.Effect.Highlight(w, options);
}

-->
</script>
'! !

!ACometWidgets methodsFor: 'html templates' stamp: 'dgd 5/9/2006 15:56'!
style
	^ '
<style>
body{	
   margin: 0px;
   height: 100%;
}
html>body{border-top : 1px solid white;}


h1 {
   font-size: 150%;
}
h2 {
   font-size: 130%;
}
h3 {
   font-size: 110%;
}

#log {
   border-left: 2px solid gray;
   background-color: #EEEEEE;
   
   float: right;
   height: 100%;
   width: 35%;
   
   overflow: auto;
   word-wrap: break-word;
}

#log div {
   border-top: 1px solid white;
   padding: 0px 5px 2px 5px;

   font-size: 80%;
}

#status {
   background-color: #f3f3f3;

   width: 100%;
}

#status div {
   padding: 3px 3px 3px 3px;
}


#contents {
   width: 100%;
   height: 100%;
   background-color: #eeeeff;
}
</style>
'! !

!ACometWidgets methodsFor: 'pushing - testing' stamp: 'dgd 9/20/2006 13:50'!
testAlertListenerId
	"
	ACometWidgets instance testAlertListenerId.
	"

	self
		push: [:socket | self script: 'alert("ListenerId:" + top.ListenerId.toString())' ].
! !

!ACometWidgets methodsFor: 'rpc' stamp: 'dgd 6/1/2006 14:51'!
widgetChanged: anArray 

	|  connectionId widgetId newValue |

	connectionId := anArray first.
	widgetId := anArray second.
	newValue := anArray third.

"	useful to see the running-gif in the browser"
"	(Delay forSeconds: 3) wait. "

	"fork action to send the response as soon as posibble"
	[
		(Delay forMilliseconds: 25) wait.
		self widget: widgetId value: newValue
	] fork.
! !

!ACometWidgets methodsFor: 'rpc' stamp: 'dgd 5/11/2006 19:10'!
widget: widgetIdString value: valueObject
	"
	ACometWidgets2 instance widget: '3' value: Time now.
	"

	| newValue |

	newValue := valueObject asString withBlanksTrimmed.

	model
		at: (widgetIdString asInteger + 1)
		put: newValue.

	self
		push: [:socket | self script: ('top.updateWidget({1}, "{2}");' format: {widgetIdString. newValue}) ]
! !

!AComet class methodsFor: 'running' stamp: 'dgd 5/5/2006 13:51'!
assembleService: assembly

	self subclassResponsibility! !

!AComet class methodsFor: 'instance creation' stamp: 'dgd 5/3/2006 09:43'!
clearInstance
	"Clear the receiver (singleton) instance"
	"
	AComet clearInstance.
	"

	instance := nil
! !

!AComet class methodsFor: 'instalation' stamp: 'dgd 5/21/2006 16:20'!
createSAR
	"
	AComet createSAR.
	"
	| zip mczStream workingCopy version |

	zip := ZipArchive new. 

	mczStream := RWBinaryOrTextStream on: (String new: 10000). 

	workingCopy := MCWorkingCopy forPackage: (MCPackage new name: 'Asteroid'). 
	version := workingCopy newVersion. 
	version fileOutOn: mczStream.

	zip
		addString: mczStream contents
		as: 'Asteroid.mcz'
            desiredCompressionLevel: 0. 

	zip
		addString: '
	Canvas
		compile: ''supportDeferredUpdates
		^ true''
		classified: ''*Asteroid-testing''
		notifying: nil.

	self fileInMonticelloZipVersionNamed: ''Asteroid.mcz''. !!

	(self membersMatching: ''files/*'') 
		do: [ :f | self extractMember: f ]. !!   
' 
		as: 'install/preamble'. 

	zip addFile: 'files/builder.js'.
	zip addFile: 'files/controls.js'.
	zip addFile: 'files/dragdrop.js'.
	zip addFile: 'files/effects.js'.
	zip addFile: 'files/icon_animated_busy.gif'.
	zip addFile: 'files/prototype.js'.
	zip addFile: 'files/scriptaculous.js'.
	zip addFile: 'files/slider.js'.
	zip addFile: 'files/unittest.js'.
	zip addFile: 'files/excanvas.js'.

	zip writeToFileNamed: 'Asteroid.sar'.
! !

!AComet class methodsFor: 'instance creation' stamp: 'dgd 5/3/2006 09:32'!
initializeInstance
	"Initialize the receiver (singleton) instance"

	instance := self new.
! !

!AComet class methodsFor: 'instance creation' stamp: 'dgd 5/3/2006 10:50'!
instance
	"Answer the (singleton) instance of the receiver"
	"
	AComet instance.
	"
	instance ifNil: [self initializeInstance].
	^ instance! !

!AComet class methodsFor: 'running' stamp: 'dgd 5/26/2006 03:26'!
reset
	"Reset the receiver"
	"
	AComet reset.
	"
	self stop.
	self clearInstance.
	self start.
! !

!AComet class methodsFor: 'running' stamp: 'dgd 5/5/2006 13:43'!
serviceName
	"Answer the receiver's intented service name"

	^ self subclassResponsibility! !

!AComet class methodsFor: 'running' stamp: 'dgd 5/5/2006 13:52'!
servicePort
	"Answer the receiver's intented service port"

	^ self subclassResponsibility! !

!AComet class methodsFor: 'running' stamp: 'dgd 10/2/2006 10:05'!
start
	"Start the stuff needed to serve"
	"
	AComet start.
	"

	| assembly service |

	self stop.

	assembly := ModuleAssembly core.

	assembly alias: '/SocketServer' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processSocketServer:
									argument: nil).
	].

	self assembleService: assembly.

	service := HttpService
						startOn: self servicePort
						named: self serviceName.

	service plug: assembly rootModule.
	"service setDeploymentMode."
	service setDebugMode.
! !

!AComet class methodsFor: 'running' stamp: 'dgd 8/8/2006 14:50'!
stop
	"Stop the associated services"

	instance isNil ifFalse:[instance stop].

	(HttpService servicesNamed: self serviceName)
		do: [:each |
				each stop.
				each waitForStop.
				each kill.
				each unregister].
! !

!AComet methodsFor: 'private' stamp: 'dgd 5/31/2006 17:10'!
cometSocketClass

	^ ACometSocket! !

!AComet methodsFor: 'private' stamp: 'dgd 10/24/2006 13:19'!
dataForSocket: socket 

	^ String streamContents: [:stream | 
			| contents response |
			contents := self pad: '<html><head></head><body>' , (self initCometSocket: socket).
			response := HttpResponse fromString: contents.
			response contentLength: nil.
			response fieldAt: 'Expires' put: '-1'"DateAndTime now asHttpString".
			response fieldAt: 'Cache-Control' put: 'no-cache, must-revalidate, no-store'.
			response fieldAt: 'Pragma' put: 'no-cache'.
			response writeOn: stream
		].
! !

!AComet methodsFor: 'pushing' stamp: 'dgd 7/5/2006 20:09'!
errorInSocket: aCometSocket

	mutex critical:[
		sockets removeKey: aCometSocket listenerId ifAbsent:[].
	].
"
	Transcript show: 'Closing: ' , aCometSocket asString; cr.
"
	aCometSocket closeGently.
	self justDisconnected: aCometSocket.
! !

!AComet methodsFor: 'rpc' stamp: 'dgd 9/5/2006 20:51'!
getParams: aDictionary
	"private - extracts the params from a JSON request dictionary"

	| result |

	result := aDictionary at: 'params' ifAbsent:[^ {}].

	result isEmptyOrNil
		ifTrue:[ ^ {} ].

	(result isKindOf: Dictionary) ifTrue:[
		| newResult |
		newResult := Array new: result size.
		result keysAndValuesDo:[:key :value | newResult at: key asInteger + 1 put: value].
		result := newResult.
	].
"
	(result size = 1)
		ifTrue:[^ result first].
"
	^ result asArray.
! !

!AComet methodsFor: 'private' stamp: 'dgd 5/9/2006 14:24'!
initCometSocket: aCometSocket

	^ self subclassResponsibility! !

!AComet methodsFor: 'initialization' stamp: 'dgd 10/31/2006 10:40'!
initialize
	"Initialize the receiver"
	super initialize.

	mutex := Semaphore forMutualExclusion.
	self initializeSockets.
	listenerId := 100.

	self initializePingProcess.
! !

!AComet methodsFor: 'initialization' stamp: 'dgd 10/31/2006 10:39'!
initializePingProcess

	pingProcess := [
		[
			(Delay forMilliseconds: self pingDelay) wait.
			self ping.
		] repeat.
	] newProcess.

	pingProcess name: 'Pinger Process'.
	pingProcess priority: Processor systemBackgroundPriority.
	pingProcess resume.
! !

!AComet methodsFor: 'initialization' stamp: 'dgd 6/1/2006 13:47'!
initializeSockets
	"Initialize the receiver's sockets"

	sockets := Dictionary new! !

!AComet methodsFor: 'rpc' stamp: 'dgd 9/3/2006 18:06'!
jsonReceiverFor: aDictionary request: aRequest
	^ self! !

!AComet methodsFor: 'rpc' stamp: 'dgd 5/8/2006 15:52'!
jsonResponseID: id result: result error: error 

	| dict string |

	dict := Dictionary new.
	dict at: 'id' put: id.
	dict at: 'error' put: error.
	dict at: 'result' put: result.

	string := (Json render: dict) convertToUTF8.

	^ HttpResponse
			fromString: string
			contentType: MIMEDocument contentTypePlainText.
! !

!AComet methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:43'!
justConnected: aCometSocket request: aRequest
! !

!AComet methodsFor: 'events - connection' stamp: 'dgd 7/5/2006 19:35'!
justDisconnected: aCometSocket! !

!AComet methodsFor: 'accessing' stamp: 'dgd 6/1/2006 13:47'!
listenerId: anInteger
	^ sockets at: anInteger! !

!AComet methodsFor: 'accessing' stamp: 'dgd 6/1/2006 13:47'!
listenerId: anInteger ifAbsent:aBlock
	^ sockets at: anInteger ifAbsent: aBlock! !

!AComet methodsFor: 'private' stamp: 'dgd 9/5/2006 21:22'!
openSocket: aRequest 

"
	| connectionId reconnectionId |

	connectionId := aRequest fields at: 'connection_id'.
	reconnectionId := aRequest fields at: 'reconnection_id' ifAbsent: [nil].
"
	"rob the socket stream"
"	self registerSocket: aRequest stream id: connectionId."
	self registerSocket: aRequest stream request: aRequest.

	"terminate the Comanche process"
	thisContext swapSender: nil.
	Processor activeProcess terminate.
! !

!AComet methodsFor: 'private' stamp: 'dgd 5/11/2006 19:26'!
pad: aString
	"PRIVATE - pad the given string with enough data to workaround transfer problems"
	| size |
	size := 512.
	^ aString size < size
			ifTrue:[aString ,  (String new: size - aString size withAll: Character space)]
			ifFalse:[aString].
! !

!AComet methodsFor: 'pushing - pinging' stamp: 'dgd 6/1/2006 13:46'!
ping
	"
	AComet instance .
	"

	| socketsCount |

	mutex critical:[
		socketsCount := sockets size.
	].

	self push: self pingBlock.

	mutex critical:[
		(socketsCount = sockets size) ifFalse:[
			Transcript show: ('{1} alive sockets (of {2}) after pinging.' format: {sockets size. socketsCount}); cr.
		]
	].
! !

!AComet methodsFor: 'pushing - pinging' stamp: 'dgd 6/1/2006 13:48'!
pingBlock
	^ [:socket | self script: ('log("Ping: {1} open sockets");' format:{sockets size}) ] fixTemps
! !

!AComet methodsFor: 'configuration' stamp: 'dgd 9/28/2006 16:41'!
pingDelay
	"Answer the delay, in milliseconds, between the pings"

	^ 30000 "30 seconds"! !

!AComet methodsFor: 'processing' stamp: 'dgd 9/3/2006 18:04'!
processSocketServer: aRequest 
	| raw |

	raw := aRequest rawPostFields.

	raw isEmpty ifTrue: [
		self openSocket: aRequest
	]
	ifFalse: [
		^ self runJSONMethod: (Json readFrom: raw convertFromUTF8 readStream) request: aRequest
	].
! !

!AComet methodsFor: 'pushing - testing' stamp: 'dgd 5/11/2006 18:59'!
pushAlertHelloWorld
	"
	AComet instance pushAlertHelloWorld.
	"

	self pushScript: [:socket | 'alert( "Hello world!!" );'].
! !

!AComet methodsFor: 'pushing' stamp: 'dgd 9/5/2006 20:10'!
pushScript: pushBlock 
	^ self push: [:socket | self script: (pushBlock value: socket)].
! !

!AComet methodsFor: 'pushing' stamp: 'dgd 5/17/2006 19:56'!
pushScript: pushBlock  reject: rejectBlock 
	^self push: [:socket | self script: (pushBlock value: socket)] reject: rejectBlock ! !

!AComet methodsFor: 'pushing' stamp: 'dgd 5/19/2006 20:35'!
pushScript: pushBlock  select: selectBlock 
	^ self
		push: [:socket | self script: (pushBlock value: socket)]
		select: selectBlock.
! !

!AComet methodsFor: 'pushing' stamp: 'dgd 5/5/2006 13:07'!
push: pushBlock

	^ self
			push: pushBlock
			select: [:socket | true ].! !

!AComet methodsFor: 'pushing' stamp: 'dgd 5/5/2006 13:07'!
push: pushBlock reject: rejectBlock 

	self
		push: pushBlock
		select:  [:socket | (rejectBlock value: socket) == false].
! !

!AComet methodsFor: 'pushing' stamp: 'dgd 9/22/2006 19:32'!
push: pushBlock select: selectBlock 

	| selectedSockets |

	mutex critical: [
		selectedSockets := sockets select: selectBlock
	].

	selectedSockets do: [:each | 
		| str |
		str := pushBlock value: each.
		str isEmpty ifFalse: [
			self send: str using: each.
		].
	].
! !

!AComet methodsFor: 'private' stamp: 'dgd 10/17/2006 20:49'!
registerSocket: aSocketStream request: aRequest

	| id socket |

	mutex critical: [
		listenerId := listenerId + 1.
		id := listenerId
	].

	socket := self cometSocketClass 
							runner: self
							stream: aSocketStream
							listenerId: id
							request: aRequest.

	mutex critical: [
		sockets at: socket listenerId put: socket
	].

	socket
		sendImmediatelly: (self dataForSocket: socket)
		ifError: [
			Transcript show: 'Can''t register socket: ' , socket asString; cr.
			^self
		].

	self justConnected: socket request: aRequest.
	socket justConnected.
! !

!AComet methodsFor: 'rpc' stamp: 'dgd 10/14/2006 11:46'!
runJSONMethod: aDictionary request: aRequest

	| id methodName params selector result error receiver |

	id := aDictionary at: 'id'.
	methodName := aDictionary at: 'method'.
	params := self getParams: aDictionary.

	result := nil.
	error := nil.

	selector := methodName asSymbol.
	receiver := self jsonReceiverFor: aDictionary request: aRequest.

"	["
	result := receiver perform: selector withArguments: params.
"	]
		on: Error
		do: [:exc | error := exc asString]."

	(result == receiver)
		ifTrue:[result := nil].

	^ self 
			jsonResponseID: id
			result: result
			error: error.
! !

!AComet methodsFor: 'html templates' stamp: 'dgd 9/20/2006 14:12'!
scriptLibrary
	^ '
<script type="text/javascript">

var ListenerId = 0;
var InvocationsInProcess = 0;
var InvokeId = 0;

function id(theId) {
	return document.getElementById(theId);
}

function log(msg) {
	var logDiv = id("log");
	if (!!logDiv) {
		return;
	}

	if (logDiv.style.visibility == "hidden") {
		return;
	}

	var message = msg;
	if (!!message) {
		message = "null";
	}

	logDiv.getElementsByTagName("div")[0].innerHTML += message.toString() + "<br/>";

     logDiv.scrollTop = logDiv.scrollHeight;
}

function logError(msg) {
	log ( "<font color=red><b>ERROR:</b> " + msg.toString() + "</font>");
}

function logWarning(msg) {
	log ( "<font color=blue>" + msg.toString() + "</font>");
}

function status(msg) {
	var logStatus = id("status");
	if (logStatus) {
		logStatus.getElementsByTagName("span")[0].innerHTML = msg;
	}
}

function toggleLog() {
	var logDiv = id("log");
	if (!!logDiv) {
		return;
	}
	if (logDiv.style.visibility == "hidden") {
		logDiv.style.visibility = "visible";
	}
	else {
		logDiv.style.visibility = "hidden";
	}
}

function connectedMessage() {
	return "<font color=green>CONNECTED</font>";
}

function connect(listId) {
	log ( "<b>CONNECTED: </b> ListenerId=" + listId.toString() );
	ListenerId = listId;

	window.defaultStatus = "Connected";
	status(connectedMessage());

	if (justConnected) {
		justConnected();
	}
}

function disconnectedMessage() {
	return "<font color=red size=+1>* DISCONNECTED *</font><br><br>Press the button to reconnect: <input type=\"button\" value=\"RECONNECT\" onClick=''reconnect()''>";
}

function disconnect() {
	logError ( "DISCONNECTED!!" );
	ListenerId = 0;

	window.defaultStatus = "* DISCONNECTED *";
	status(disconnectedMessage());

	if (justDisconnected) {
		justDisconnected();
	}
}

function isConnected() {
	return ListenerId !!= 0;
}

function createXmlHttp() {
	var xmlhttp = false;

	/*@cc_on @*/
	/*@if (@_jscript_version >= 5)
	// JScript gives us Conditional compilation, we can cope with old IE versions.
	// and security blocked creation of the objects.
	try {
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
		try {
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (E) {
			xmlhttp = false;
		}
	}
	@end @*/
      
	if (!!xmlhttp && typeof XMLHttpRequest!!="undefined") {
		try {
			xmlhttp = new XMLHttpRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}
      
	if (!!xmlhttp && window.createRequest) {
 		try {
			xmlhttp = window.createRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}

	return xmlhttp;
}

function plainReconnect() {
	var iframe = id("CometIFrame");
	if (!!iframe) {
		logError ( "The IFrame with id=CometIFrame is not present" );
		return;
	}
	logWarning ( "Trying to reconnect...");
	iframe.src = "/SocketServer?random=" + Math.random().toString();
}

function reconnect() {
	//if (!!isConnected()) {
	//	return;
	//}

	if (isConnected()) {
		disconnect();
	}

	plainReconnect();
	//setTimeout(plainReconnect, 2000);
}

function showStatusWheel() {
	InvocationsInProcess = InvocationsInProcess + 1;
	if (InvocationsInProcess > 0) {
		var logStatus = id("status");
		if (logStatus) {
			var img = logStatus.getElementsByTagName("img")[0];
			if (img.style.visibility !!= "visible") {
				img.style.visibility = "visible";
			}
		}		
	}
}

function hideStatusWheel() {
	InvocationsInProcess = InvocationsInProcess - 1;
	if (InvocationsInProcess <= 0) {
		var logStatus = id("status");
		if (logStatus) {
			logStatus.getElementsByTagName("img")[0].style.visibility = "hidden";
		}
	}
}

function invokeJsonRPCMethod(method, params, async, loged) {
	if (typeof params == "undefined") {
		params = null;
	}

	if (typeof loged == "undefined") {
		loged = true;
	}

	if (!!isConnected()) {
		if (loged) {
			logError( "can''t invoke methods while disconnected" );
		}
		return;
	}

	showStatusWheel();

	InvokeId = InvokeId + 1;

	var requestObject = Object();
	requestObject["id"] = InvokeId;
	requestObject["method"] = method;
	requestObject["params"] = params;

	if (loged) {
		log( "<b>Request:</b>" + requestObject.toJSONString() );
	}

	var xmlhttp = createXmlHttp();
	if (!!xmlhttp) {
		hideStatusWheel();
		return;
	}

	if (typeof async == "undefined") {
		async = true;
	}

	xmlhttp.open("POST", "/SocketServer?random=" + Math.random().toString(), async);
	if (async) {
		xmlhttp.onreadystatechange = function() {
				if (xmlhttp.readyState == 4) {
					var response = xmlhttp.responseText.parseJSON();
					if (loged) {
						log( "<b>Response:</b>" + response.toJSONString() );
					}

					hideStatusWheel();
				}
			}
		xmlhttp.send( requestObject.toJSONString() );

		return true;
	}
	else {
		xmlhttp.send( requestObject.toJSONString() );

		var response = xmlhttp.responseText.parseJSON();
		if (loged) {
			log( "<b>Response:</b>" + response.toJSONString() );
		}

		hideStatusWheel();

		return response["result"];
	}
}


/* hook functions */
function justConnected() {
}

function justDisconnected() {
}

</script>
'! !

!AComet methodsFor: 'html templates' stamp: 'dgd 5/16/2006 13:32'!
scriptLibraryJSON
	^'
<script type="text/javascript">
<!!--
/*
    json.js
    2006-04-28

    This file adds these methods to JavaScript:

        object.toJSONString()

            This method produces a JSON text from an object. The
            object must not contain any cyclical references.

        array.toJSONString()

            This method produces a JSON text from an array. The
            array must not contain any cyclical references.

        string.parseJSON()

            This method parses a JSON text to produce an object or
            array. It will return false if there is an error.
*/
(function () {
    var m = {
            "\b": "\\b",
            "\t": "\\t",
            "\n": "\\n",
            "\f": "\\f",
            "\r": "\\r",
            ''"'' : ''\\"'',
            "\\": "\\\\"
        },
        s = {
            array: function (x) {
                var a = ["["], b, f, i, l = x.length, v;
                for (i = 0; i < l; i += 1) {
                    v = x[i];
                    f = s[typeof v];
                    if (f) {
                        v = f(v);
                        if (typeof v == "string") {
                            if (b) {
                                a[a.length] = ",";
                            }
                            a[a.length] = v;
                            b = true;
                        }
                    }
                }
                a[a.length] = "]";
                return a.join("");
            },
            "boolean": function (x) {
                return String(x);
            },
            "null": function (x) {
                return "null";
            },
            number: function (x) {
                return isFinite(x) ? String(x) : "null";
            },
            object: function (x) {
                if (x) {
                    if (x instanceof Array) {
                        return s.array(x);
                    }
                    var a = ["{"], b, f, i, v;
                    for (i in x) {
                        v = x[i];
                        f = s[typeof v];
                        if (f) {
                            v = f(v);
                            if (typeof v == "string") {
                                if (b) {
                                    a[a.length] = ",";
                                }
                                a.push(s.string(i), ":", v);
                                b = true;
                            }
                        }
                    }
                    a[a.length] = "}";
                    return a.join("");
                }
                return "null";
            },
            string: function (x) {
                if (/["\\\x00-\x1f]/.test(x)) {
                    x = x.replace(/([\x00-\x1f\\"])/g, function(a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return "\\u00" +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    });
                }
                return ''"'' + x + ''"'';
            }
        };

    Object.prototype.toJSONString = function () {
        return s.object(this);
    };

    Array.prototype.toJSONString = function () {
        return s.array(this);
    };
})();

String.prototype.parseJSON = function () {
    try {
        return !!(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*"/g, ""))) &&
            eval("(" + this + ")");
    } catch (e) {
        return false;
    }
};
-->
</script>
'! !

!AComet methodsFor: 'pushing' stamp: 'dgd 9/28/2006 16:35'!
script: aString

	aString withBlanksTrimmed isEmpty
		ifTrue:[Transcript show: '-- empty script.'; cr. ^ ''].
 
	^ '<script>' , aString withBlanksTrimmed , '</script>
<hr>
'! !

!AComet methodsFor: 'pushing' stamp: 'dgd 9/22/2006 19:34'!
send: aString using: aCometSocket 

	[
		aCometSocket
			sendImmediatelly: (self pad: aString)
			ifError: [ self errorInSocket: aCometSocket ].
	] fork.
! !

!AComet methodsFor: 'accessing' stamp: 'dgd 9/5/2006 22:20'!
sockets
	"Answer the receiver's sockets collection"
	^ sockets! !

!AComet methodsFor: 'processing' stamp: 'dgd 6/15/2006 16:14'!
stop

	pingProcess isNil ifFalse:[
		pingProcess terminate.
		pingProcess := nil.
	].

	sockets do:[:each | 
		[ each close ]
			on: Error
			do: [:error | ]
	].

	mutex critical:[
		self initializeSockets.
	].
! !

Object subclass: #ACometSocket
	instanceVariableNames: 'stream listenerId properties runner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Asteroid-Core'!

!ACometSocket class methodsFor: 'instance creation' stamp: 'dgd 9/14/2006 20:09'!
runner: aCometRunner stream: aSocketStream listenerId: listenerIdInteger request: aRequest
	^ self new
				initializeRunner: aCometRunner
				stream: aSocketStream
				listenerId: listenerIdInteger
				request: aRequest! !

!ACometSocket methodsFor: 'connection' stamp: 'dgd 5/5/2006 13:06'!
close

	stream close.
	stream socket closeAndDestroy: 1.
! !

!ACometSocket methodsFor: 'connection' stamp: 'dgd 6/1/2006 13:42'!
closeGently
	[
		self close
	]
		on: Error
		do: [:exc | ].
! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 9/5/2006 20:17'!
hasProperty: anObject

	properties at: anObject ifAbsent:[^ false].

	^ true! !

!ACometSocket methodsFor: 'initialization' stamp: 'dgd 5/26/2006 16:07'!
initialize

	properties := Dictionary new.! !

!ACometSocket methodsFor: 'initialization' stamp: 'dgd 9/20/2006 13:48'!
initializeRunner: aCometRunner stream: aSocketStream listenerId: listenerIdInteger request: aRequest

	runner := aCometRunner.
	stream := aSocketStream.
	listenerId := listenerIdInteger.

	self justCreatedFromRequest: aRequest.
! !

!ACometSocket methodsFor: 'connection' stamp: 'dgd 9/20/2006 17:45'!
justConnected
! !

!ACometSocket methodsFor: 'connection' stamp: 'dgd 9/14/2006 20:11'!
justCreatedFromRequest: aRequest
	"The receiver was just created from the given http request"
! !

!ACometSocket methodsFor: 'accessing' stamp: 'dgd 5/5/2006 12:56'!
listenerId
	"Answer the receiver's listenerId"
	^ listenerId! !

!ACometSocket methodsFor: 'printing' stamp: 'dgd 9/20/2006 13:40'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPutAll: ' listenerId:';
		nextPutAll: listenerId asString! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:07'!
propertyAt: anObject

	^ properties at: anObject.
! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:08'!
propertyAt: aSymbol ifAbsentPut: absentBlock

	^properties at: aSymbol ifAbsentPut: absentBlock! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:08'!
propertyAt: aSymbol ifAbsent: absentBlock

	^properties at: aSymbol ifAbsent: absentBlock! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:07'!
propertyAt: aSymbol put: anObject

	properties at: aSymbol put: anObject! !

!ACometSocket methodsFor: 'pushing' stamp: 'dgd 9/3/2006 20:45'!
pushScript: aBlock
	runner 
		pushScript: aBlock
		select: [:socket | socket == self].! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:08'!
removePropertyAt: aSymbol

	properties removeKey: aSymbol! !

!ACometSocket methodsFor: 'accessing - properties' stamp: 'dgd 5/26/2006 16:08'!
removePropertyAt: aSymbol ifAbsent: aBlock

	^properties removeKey: aSymbol ifAbsent: aBlock! !

!ACometSocket methodsFor: 'accessing' stamp: 'dgd 9/5/2006 12:32'!
runner
	"Answer the receiver's runner"
	^ runner! !

!ACometSocket methodsFor: 'connection' stamp: 'dgd 6/7/2006 12:46'!
sendImmediatelly: aString ifError: errorBlock
	^ stream sendImmediatelly: aString ifError: errorBlock! !

!ACometSocket methodsFor: 'accessing' stamp: 'dgd 5/5/2006 12:55'!
stream
	"Answer the receiver's stream"
	^ stream! !

!Object methodsFor: '*Asteroid-printing' stamp: 'dgd 5/19/2006 17:09'!
asCanvasString
	^ self asString! !

!Number methodsFor: '*Asteroid-printing' stamp: 'dgd 5/17/2006 13:07'!
asHtmlValue
	^ (self * 255) asInteger printStringBase: 16 length: 2
! !

!Color methodsFor: '*Asteroid-printing' stamp: 'dgd 5/17/2006 13:08'!
asCanvasString
"
(Color red alpha: 0.5) asCanvasString.
"
	^ '''#{1}{2}{3}'''  format: {self red asHtmlValue. self green asHtmlValue. self blue asHtmlValue}.
! !

!NetworkHost methodsFor: '*Asteroid-accessing' stamp: 'dgd 5/5/2006 19:08'!
nameString
	^ String streamContents: [ :str |
			self name do: [:nm | str nextPutAll: nm asString] separatedBy: [str nextPut: $.] ]
! !

!Rectangle methodsFor: '*Asteroid-javascript' stamp: 'dgd 5/17/2006 15:02'!
asCanvasString

	^ '{1},{2}' format: {self topLeft asCanvasString. self extent asCanvasString}
! !

!SocketStream methodsFor: '*Asteroid-printing' stamp: 'dgd 5/3/2006 11:06'!
printOn: aStream
	aStream
		nextPutAll: 'a ';
		nextPutAll: self class name asString.

	socket isNil ifFalse:[
		aStream
			nextPutAll: ' ';
			nextPutAll: 'connected to: ' , socket remoteAddress printString.
	].
! !

!SocketStream methodsFor: '*Asteroid-stream out' stamp: 'dgd 6/14/2006 19:59'!
sendImmediatelly: aString ifError: errorBlock
	"Send the given string immediatelly"

	| ok |

	self flush.

	ok := (self socket isValid)
				and: [self socket isConnected]
				and: [self socket isOtherEndClosed not]
				and: [self socket pushData: aString].

	ok ifFalse:[errorBlock value].

	^ ok! !

!String methodsFor: '*Asteroid-formatting' stamp: 'dgd 5/19/2006 17:09'!
canvasFormat: aCollection
	^ self format: (aCollection collect:[:each | each asCanvasString])! !

!String methodsFor: '*Asteroid-converting' stamp: 'dgd 5/8/2006 15:49'!
convertFromUTF8
	^ self convertFromWithConverter: UTF8TextConverter new! !

!String methodsFor: '*Asteroid-converting' stamp: 'dgd 5/8/2006 15:50'!
convertToUTF8
	^ self convertToWithConverter: UTF8TextConverter new! !

!String methodsFor: '*Asteroid-displaying' stamp: 'dgd 5/17/2006 15:45'!
displayOn: aDisplayMedium at: aPoint textStyle: aTextStyle textColor: textColorColor backgroundColor: backgroundColor

	((DisplayText text: self asText textStyle: aTextStyle)
			foregroundColor: (textColorColor ifNil: [Color black])
			backgroundColor: (backgroundColor ifNil:[Color white]))
		displayOn: aDisplayMedium at: aPoint.
! !

!DateAndTime methodsFor: '*Asteroid-printing' stamp: 'dgd 5/11/2006 17:00'!
asHttpString
"self localTimeZone."

	^
		'{1}, {2} {3} {4} {5}:{6}:{7} {8}'
				format: {
							self dayOfWeekAbbreviation.
							self dayOfMonth.
							self monthAbbreviation.
							self year.
							0.
							0.
							0.
							'GMT'
				}.
! !

!Integer methodsFor: '*Asteroid-printing' stamp: 'dgd 5/17/2006 13:04'!
printStringBase: base length: minimum
	^ self printStringBase: base length: minimum padded: true! !

!Point methodsFor: '*Asteroid-javascript' stamp: 'dgd 5/19/2006 11:38'!
asCanvasString

	^ '{1},{2}' format: {self x rounded. self y rounded}
! !

!Form methodsFor: '*Asteroid-converting' stamp: 'dgd 5/23/2006 10:38'!
asPNGBase64Encoded

	|  stream base64 cr |

	stream := self asPNGByteArray readStream.

	base64 := (Base64MimeConverter mimeEncode: stream) contents.

	cr := Character cr.

	^ base64 reject: [:each | each = cr].
! !

!Form methodsFor: '*Asteroid-converting' stamp: 'dgd 5/23/2006 10:23'!
asPNGByteArray
	
	| stream rw |

	stream := RWBinaryOrTextStream on: String new.
	rw := PNGReadWriter on: stream.
	rw nextPutImage: self.
	rw close.
	stream reset.

	^ stream contents.
! !

!HttpRequest methodsFor: '*Asteroid-accessing' stamp: 'dgd 5/9/2006 15:35'!
rawPostFields
	"save the POST form fields as is, for future processing, see #postFields"

	^ self
			propertyAt: #rawPostFields
			ifAbsentPut: [stream next: self contentLength].! !

!Archive methodsFor: '*Asteroid-archive operations' stamp: 'dgd 5/9/2006 16:47'!
addString: aString as: aFileName desiredCompressionLevel: aNumber

	^ (self addString: aString as: aFileName)
			desiredCompressionLevel: aNumber;
			yourself! !
ACometWidgets initialize!
